
import java.awt.*;
import java.awt.Image;
import java.awt.MediaTracker;
import java.awt.event.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Vector;

import javax.swing.*;
import javax.swing.JComponent;
import javax.swing.Timer;

public class Flyer extends JComponent implements ActionListener
{
	private JComponent himmel;//Die Componente in der der Flyer is (JPanel...)
	private Vector imagesRO = new Vector();//Die ganzen bilder die die Animation des Flyers nach rechts ausmachen
	private Vector imagesLO = new Vector();//Die ganzen bilder die die Animation des Flyers nach links ausmachen
	private Vector imagesRU = new Vector();//Die ganzen bilder die die Animation des Flyers nach rechts ausmachen
	private Vector imagesLU = new Vector();//Die ganzen bilder die die Animation des Flyers nach links ausmachen
	private Timer timer;//nix wichtiges nur zum aufrumen interessant
	private int waitMillis;//Aus performanzgrnden kann der wert erhht werden um weniger Repaints zu erhalten;
	private Image actual,matsch,respawnImg;//Aktuell gezeichnetes bild
	private int imageCount;//anzhal der Bilder die in der Animation sind
	private int countImage;//aktuelle id des Bildes;
	
   	private double xD,yD; 					//location des Flyers
   	private double direction; 				//Richtung: Kreispunkt in grad, 0 = pos X-Axe
   	private double speed; 					//Geschwindigkeit: pixels pro "fly" interval
   	private boolean besoffen		= true;	//ndert seine Richtung selbstndig und "Unkontrolliert"
   	private boolean totalBesoffen = false;
   	private boolean alwaysFly 	= true;	//Wenn bern rand dann furt
   	private boolean dying			= false;	//Stirbt
   	private boolean dead	  		= false;	//Tot;
	private boolean jesus			= true; 	//kann wieder Auferstehen
	private boolean respawn		= false;	//respawned gerade
	private boolean ausruhen		= false;
	private int dyingCounter = 0;
	private int respawnCounter = 0;
	private int totalBesoffenCounter = 0;
	
	public Flyer()
	{
		
	}
	public void init(String imageName,int imageCount,int waitMillis,JComponent owner)
	{
		this.imageCount = imageCount;
		this.waitMillis = waitMillis;
		this.himmel = owner;
		this.xD = Math.random()*himmel.getWidth()-this.getWidth()-1;
		this.yD = Math.random()*himmel.getHeight()-this.getHeight()-1;
		this.setBounds((int)xD,(int)yD,(int)(Math.random()*20+10),(int)(Math.random()*20+10));
		this.speed = (int)(Math.random()*5+1);
		this.addMouseListener(new MouseAdapter()
		{
			public void mouseEntered(MouseEvent e)
			{
				mEnter(e);
			}	
			public void mouseExited(MouseEvent e)
			{
				mExit(e);	
			}
			public void mousePressed(MouseEvent e)
			{
				mPresse(e);	
			}
		});
		this.addMouseMotionListener(new MouseMotionAdapter()
		{
			public void mouseMoved(MouseEvent e)
			{
				mMove(e);	
			}
		});
		MediaTracker m = new MediaTracker(this);
		for(int i=0;i<imageCount;i++)
		{
			imagesRO.add(this.getToolkit().getImage(imageName+i+"RO.gif").getScaledInstance(this.getWidth(),this.getHeight(),Image.SCALE_SMOOTH));
			m.addImage((Image)imagesRO.elementAt(i),i);
			imagesLO.add(this.getToolkit().getImage(imageName+i+"LO.gif").getScaledInstance(this.getWidth(),this.getHeight(),Image.SCALE_SMOOTH));
			m.addImage((Image)imagesRO.elementAt(i),i);
			imagesRU.add(this.getToolkit().getImage(imageName+i+"RU.gif").getScaledInstance(this.getWidth(),this.getHeight(),Image.SCALE_SMOOTH));
			m.addImage((Image)imagesRU.elementAt(i),i);
			imagesLU.add(this.getToolkit().getImage(imageName+i+"LU.gif").getScaledInstance(this.getWidth(),this.getHeight(),Image.SCALE_SMOOTH));
			m.addImage((Image)imagesRU.elementAt(i),i);
			
		}
		matsch = this.getToolkit().getImage(imageName+"Dead.gif").getScaledInstance(this.getWidth(),this.getHeight(),Image.SCALE_SMOOTH);
		m.addImage(matsch,imageCount+1);
		respawnImg = this.getToolkit().getImage(imageName+"Respawn.gif").getScaledInstance(this.getWidth(),this.getHeight(),Image.SCALE_SMOOTH);
		m.addImage(respawnImg,imageCount+2);

	
		// Laden der bentigten Wav-Files
		// 1 WAV-Datei fr den Ausruh-,die-Sound und den Respawn-Sound
		// bel. viele Sounds fr wegfliegende Schmetterlinge
		
		
			
		/* ******************************* ******************************* 
		 * 
		 * Hier werden die ganzen Soundfiles fr die Applikation erzeugt!!!
		 * *************************************************************** */
			 
			

		try
		{
			m.waitForAll();
		}
		catch (InterruptedException e)
		{
			System.out.println("Mediatracker was Interupted:"+e);
			e.printStackTrace();
		}
		
	}

	/**
	 * Method mPresse.
	 * @param e
	 */
	private void mPresse(MouseEvent e)
	{
		if(ausruhen)
		{
			// Schmetterling wurde gefangen nun wird er erdrckt... Abspielen des Die-sounds!
			
			this.dying = true;	
			this.ausruhen = false;
			this.actual = matsch;
			this.repaint();
		}
	}

	private void mEnter(MouseEvent e)
	{
		if(!dying)
		{
				// Wahrscheinlichkeit mit der ein Schmetterling sich am Mauszeiger ausruht
				if(Math.random()*100 <10)
				{
	    	 		// Schemtterling bleibt liegen und ruht sich aus -> Ausruh-Sound speilen
	    	 		
		 			ausruhen = true;	
				}
				else
				{
					//Schmetterling hat dich erkannt und fliegt schnell udn wir weg... Du Schlingel!
					// Abspielen eines zuflligen totalBesoffenSounds
					totalBesoffen = true;	
				}
			
			
		}
	}
	private void mMove(MouseEvent e)
	{
		if(!dying)
		{
			this.setBounds(this.getX()+(int)e.getX()-this.getWidth()/2,this.getY()+(int)e.getY()-this.getHeight()/2,this.getWidth(),this.getHeight());
		}
	}
	private void mExit(MouseEvent e)
	{
		this.xD = this.getX();
		this.yD = this.getY();
		ausruhen = false;	
	}
	
	public void actionPerformed(ActionEvent e)
	{
		fly();	
	}
	
	private void fly()
	{
	  if(dying)
	  {
	  	die();
	  	return;	
	  }
	  if(respawn)
	  {
	  	respawning();
	  	return;
	  }
	  if(ausruhen)
	  {
	   	this.actual = (Image)imagesLO.elementAt(0);
	  	return;
	  }	
	  if(besoffen)
	  {
	 	  setDirection(getDirection() + (float)(45*(Math.random()-.5)));      
	  }
	  if(totalBesoffen)
	  {
		seiBesoffen();
	  }
	  	this.xD 	= (double)(xD + (speed * Math.cos(direction*Math.PI/180.)));
      	this.yD 	= (double)(yD - (speed * Math.sin(direction*Math.PI/180.)));
	  
      int w 	= himmel.getWidth();
      int h 	= himmel.getHeight();
      
      if (xD+this.getWidth()  > w|| xD<0) // out of range horizontally
      { 
      	if(alwaysFly)
        {
       	 	direction = 180 - direction;
         	xD = Math.min(Math.max(xD, 0), w);
        }
        else
        {
        	this.dead = true;
        }
      }
      if (yD+this.getHeight()  > h|| yD<0) // out of range vertically
      { 
      	if(alwaysFly)
        {
		 direction = - direction;
         yD = Math.min(Math.max(yD, 0), h);
        }
        else
        {
        	this.dead = true;	
        }
      }
      this.setBounds((int)xD,(int)yD,this.getWidth(),this.getHeight());
	  if(Math.sin(direction*Math.PI/180.)>0)
	  {
	  	if(Math.cos(direction*Math.PI/180.)>0)
	   	{
	    	this.actual = (Image)imagesRO.elementAt(countImage%imageCount);
	  	}
	  	else
	  	{
	   	this.actual = (Image)imagesLO.elementAt(countImage%imageCount);
	  	}
	  }
	  else
	  {
	  	if(Math.cos(direction*Math.PI/180.)>0)
	  	{
	   		this.actual = (Image)imagesRU.elementAt(countImage%imageCount);
	  	}
	  	else
	  	{
	   		this.actual = (Image)imagesLU.elementAt(countImage%imageCount);
	  	}
	  }
		  countImage= (countImage%imageCount)+1;	
	}

	/**
	 * Method seiBesoffen.
	 */
	private void seiBesoffen()
	{		
		if(totalBesoffenCounter<100)
		{
			this.speed = (int)(Math.random()*10+30);
			totalBesoffenCounter++;
			return;		
		}
		this.speed = (int)(Math.random()*5+1);
		totalBesoffen = false;
		totalBesoffenCounter = 0;
	}


	/**
	 * Method respawning.
	 */
	private void respawning()
	{
		
		if(respawnCounter<100)
		{
                        /*..und eine Melodie wenn der Schmetterling wieder zum Leben erwacht*/
			this.actual = respawnImg;
			respawnCounter++;
			repaint();
			return;
		}
		respawn = false;
		respawnCounter = 0;
		totalBesoffen = true;
	}


	/**
	 * Method die.
	 */
	private void die()
	{
		if(dyingCounter<50)
		{
			dyingCounter++;	
		}
		else
		{
			dead();	
		}
		
	}

	/**
	 * Method dead.
	 */
	private void dead()
	{
		if(jesus)
		{
			respawn();
		}
		else
		{
			goToHell();		
		}
	}

	/**
	 * Method goToHell.
	 */
	private void goToHell()
	{
		timer.stop();
		himmel.remove(this);
		himmel.repaint();
	}


	/**
	 * Method respawn.
	 */
	private void respawn()
	{
		dying 	= false;
		dyingCounter = 0;
		dead 	= false;
		respawn = true;
	}



	/**
	 * @see java.awt.Component#paint(Graphics)
	 */
	public void paint(Graphics g)
	{
//		g.drawRect(0,0,this.getWidth()-1,this.getHeight()-1);	
   		try
   		{
   			g.drawImage(actual,0,0,this);
   		}
   		catch(Exception e){}
	}
	public void start()
	{
		timer = new Timer(waitMillis,this);
		timer.start();
	}	
	public void stop()
	{
		timer.stop();	
	}


	public double getDirection() 
	{ 
		return direction; 
	}
	public void setDirection(double newDirection) 
	{ 
		direction = newDirection; 
	}

	


}

